#include "stdafx.h"
#include "time.h"
#include "assert.h"
#include <string>

using namespace std;
#define  T_POWERON 2

int g_flag = 0;

void set_N3_gain(int gain);
void switch_N4(int addr);

/********************************************************************************
*								Ŷ									*
********************************************************************************/
//Digital pin definition
DPin_t allpin[17]={3, 4, 5, 6, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28};//All pins
DPin_t inpin[4] ={3, 4, 5, 6};//All input pins
DPin_t outpin[13]={16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28};//All output pins

CVector vec;

CBIT128 cbit;

FPVI10 Vcc(0, "Vcc");//15V
FPVI10 Vee(1, "Vee");//-15V
FPVI10 Vdd(2, "Vdd");//+5V

FOVI qvi4(8, "qvi4");

QVM pvm0(0);
AWG awg0;

//Relays define 
const BYTE K1 = 56;
const BYTE K2 = 57;
const BYTE K3 = 58;
const BYTE K4 = 59;
const BYTE K5 = 60;
const BYTE K6 = 61;
const BYTE K7 = 62;
const BYTE K8 = 63;
const BYTE K9 = 43;
const BYTE K10= 42;
const BYTE K11= 41;

void Initialize()
{	

	

	char temp[100]="";
	GetCurrentDirectory(100,temp);
	string dir(temp);
	int x = dir.find("source");
	if (x > 0)
	{
		string newdir = dir.substr(0,x);
		SetCurrentDirectory(newdir.c_str());
	}

	vec.SetVectorFile("AD574-PCB.vec");
	

}




void InitBeforeTest()
{
	cbit.Init();
	set_N3_gain(1);
	switch_N4(0);

	Vcc.SetClamp(30, 30);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);

	Vee.SetClamp(40, 40);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);

	Vdd.SetClamp(60, 60);
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_OFF);

	vec.Load();

	qvi4.SetClamp(20, 20);		
	qvi4.Set(FV, 0, FOVI_5V, FOVI_10MA, RELAY_OFF);

	pvm0.Init();
	awg0.Init();
}
void InitAfterTest()
{
	cbit.Init();
	set_N3_gain(1);
	switch_N4(0);

	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_OFF);

	vec.Unload();
	qvi4.Set(FV, 0, FOVI_5V, FOVI_10MA, RELAY_OFF);
	pvm0.Init();
	awg0.Init();
}
	
void Create_Awg_Data(void)
{
	//ҪԵĵ
	int ucBits=12;			//A/Dλ
	int NUM_PER_LSB=15;		//ÿ̨׸15
	int EZ_ADD_POINT=150;	//ΪĶɨ10LSB
	int EG_ADD_POINT=150;	//ΪĶɨ10LSB
	double VRang=10.;		//ѹķΧ 
	
	int  ScanPoint=0;						//all scan point number
	double CodeNUM=0.;						//ֵ
	double CodePoint=0.;					//0-10V
	CodeNUM = pow(2,ucBits);			//4096
	CodePoint=CodeNUM * NUM_PER_LSB;	//4096*15=61440
	ScanPoint = (unsigned long)CodePoint + EZ_ADD_POINT + EG_ADD_POINT;	
	//޶ɨNUM_SCAN_ADD61440+150+150=61740
	
	double * ScanPointVolt=new double[65536];
	assert(ScanPointVolt);
	// ÿɨѹֵ	
	for(int i=0;i<ScanPoint;i++)
	{
		ScanPointVolt[i] = (VRang/CodePoint)*(i-150);
		//Scan from -0.026041667(i=0) to 10.024251302(i=61739).
	}
	
	awg0.LoadData(ScanPointVolt, ScanPoint, AWG_VRNG_10V);
	awg0.LoopEnable(100, AWG_EXT, UP);
    awg0.CNTCLR();
	awg0.CNTEnable();
	awg0.Setup(AWG_VRNG_10V, AWG_Filter);
    awg0.Connect();	
	delete[] ScanPointVolt;

}





//////////////////////////////////////////////////////////////////////////

DUT_API int Loadvec(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Vecname = StsGetParam(funcindex,"Vecname");
 
    //}}AFX_STS_PARAM_PROTOTYPES
/*	if (g_flag == 0)
	{
		char sCondName[50];
		memset(sCondName,0,50);
		Vecname->GetConditionSymbol(0,sCondName,50);
		
		strcat(sCondName, ".vec");
		g_flag=1;            ////־λ־ѵVEC
		char temp[100]="";
		GetCurrentDirectory(100,temp);
		string dir(temp);
		int x = dir.find("source");
		if (x > 0)
		{
			string newdir = dir.substr(0,x);
			SetCurrentDirectory(newdir.c_str());
		}
		
    	vec.SetVectorFile(sCondName);
		delay_ms(50);
		vec.Load();
	}*/
    
    return 0;
}

//////////////////////////////////////////////////////////////////////////








DUT_API int Error(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Ez = StsGetParam(funcindex,"Ez");
    CParam *Eg = StsGetParam(funcindex,"Eg");
    CParam *DNL = StsGetParam(funcindex,"DNL");
    CParam *INL = StsGetParam(funcindex,"INL");
    //}}AFX_STS_PARAM_PROTOTYPES
    int g_print=Ez->GetConditionValueSelOrder("g_print");

	if (g_print==0)
	{


	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K9);

	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vdd.Set(FV, 5, FPVI10_10V, FPVI10_100MA, RELAY_ON);

	delay_ms(5);

	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	delay_ms(2);	
	Create_Awg_Data();
	delay_ms(150);
    vec.UseVoltageSet(0);
	delay_ms(2);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
 	delay_ms(5);
	vec.Run(0,4);
	delay_ms(3100);
	while(vec.Running());
	DWORD ern = vec.GetResult();
	if(ern)
	{	
			DWORD * pea = new DWORD[61740];
			BYTE * buf = new BYTE [802620];
			int data_num[4096]={0};
			
			assert(pea != NULL);
			assert(buf != NULL);

			vec.GetFailData(ern,pea,buf,outpin,SIZEOF_ARRAY(outpin));

			int adc_data;
		    int i,j;
			int mid_data[12];
			int k;
			for(i=0;i<4096;i++)
			{
				data_num[i]=0;
			}
			for(i=0;i<(int)ern;i++)
			{
			    j=i*13;
				for(k=0;k<12;k++)
				{
					mid_data[k]=(int)buf[j+k];
				}
				adc_data=(mid_data[11]<<11) | (mid_data[10]<<10) | (mid_data[9]<<9) | (mid_data[8]<<8) | (mid_data[7]<<7) | (mid_data[6]<<6) | (mid_data[5]<<5) | (mid_data[4]<<4) | (mid_data[3]<<3) | (mid_data[2]<<2) | (mid_data[1]<<1)|mid_data[0];
                data_num[adc_data]++;          
		
			}
//////////////////////////////////////////////////////////////////
			//ظһ
		    int add_test_time=2;
		 	for(int test_time=1;test_time<add_test_time;test_time++)
			{
				awg0.CNTCLR();
				awg0.CNTEnable();
				delay_ms(10);
				
				vec.Run(0,4);
				
				delay_ms(3100);
				while(vec.Running());
				
				DWORD ern = vec.GetResult();

				vec.GetFailData(ern,pea,buf,outpin,SIZEOF_ARRAY(outpin));
				for(i=0;i<(int)ern;i++)
				{
					j=i*13;
					for(k=0;k<12;k++)
					{
						mid_data[k]=(int)buf[j+k];
					}
					
					adc_data=(mid_data[11]<<11) | (mid_data[10]<<10) | (mid_data[9]<<9) | (mid_data[8]<<8) | (mid_data[7]<<7) | (mid_data[6]<<6) | (mid_data[5]<<5) | (mid_data[4]<<4) | (mid_data[3]<<3) | (mid_data[2]<<2) | (mid_data[1]<<1)|mid_data[0];
					data_num[adc_data]++;          
				
				}
			}
			vec.OpenPinRelay(allpin,SIZEOF_ARRAY(allpin));
			delay_ms(2);
			awg0.CNTCLR();
			awg0.SetOutput(0,AWG_VRNG_10V);
			awg0.Disconnect();
			awg0.SetREF(0);
			awg0.REFDisConnect();
			cbit.SetCBITOff(K1);
			cbit.SetCBITOff(K9);


			Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_ON);	
			Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);			
			Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);

			unsigned long all_data_num=0;
			for( i=1; i<4095; i++)
			{
				all_data_num+=data_num[i];
			}
			
		

			int lsb1=0;
			double lsb=0.0;
			lsb1=int(all_data_num/4094+0.5);
			lsb=all_data_num/4094.0;


			double Ez_result;		           //
			Ez_result=(double)(data_num[0]-300-lsb/2.0)/lsb;
//			Ez_result=(double)(data_num[0]-150-lsb/2.0)/lsb;
			
			double Eg_result;		           //
			Eg_result=(double)(600+lsb1-data_num[4095]-data_num[0])/lsb;

			int diff_err=0;
			int max_err=0;
			double DNL_result;
            for(i=1;i<4095;i++)         //΢
			{
				diff_err=data_num[i]-lsb;
				if(fabs(diff_err)>fabs(max_err))
				max_err=diff_err;
			}
			DNL_result=(double)max_err/lsb;
			
            double INL_result=0.0,tmp_inl=0.0; //
			for(i=1;i<4095;i++)
			{
				tmp_inl=0.0;
				for(j=1;j<=i;j++)
				{
					tmp_inl+=data_num[j];
				}
				tmp_inl=tmp_inl-(((double)data_num[i]/2.0)+(double)lsb*(i-0.5));
				if(fabs(tmp_inl)>fabs(INL_result))
				{
					INL_result=tmp_inl;
				}
			}
			INL_result/=(double)lsb;	
			delete [] pea;
			delete [] buf;
			Ez->SetTestResult(0,0,Ez_result);
			Eg->SetTestResult(0,0,Eg_result);
			INL->SetTestResult(0,0,INL_result);
			DNL->SetTestResult(0,0,DNL_result);
		
	}

	}
    else
	{
			char filename[100] ="";
	char temp[100]="";
	char temp1[100]="";
	time_t chktime;
	struct tm *today;
	time(&chktime);
	today = localtime(&chktime);
	
	GetCurrentDirectory(100,temp);
	for(int m=0;m<100;m++)
	{
		temp1[m]=temp[m];
	}
	CreateDirectory("Test Data",NULL);
	strcat(temp,"\\Test Data\\");
	SetCurrentDirectory(temp);
	
	strcat(filename, " AD TEST DATA ");
	sprintf(temp, "%d", today->tm_hour);
	strcat(filename, temp);
	sprintf(temp, "%d", today->tm_min);
	strcat(filename, "-");
	strcat(filename, temp);
	sprintf(temp, "%d", today->tm_sec);
	strcat(filename, "-");
	strcat(filename, temp);
	strcat(filename, ".txt");

	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K9);

//	Vee.Connect();
//	Vcc.Connect();
// 	Vdd.Connect();
//    Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_100MA,30e-3,-30e-3);
//	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_100MA,40e-3,-40e-3);
//	Vdd.SetModeFVMI(PVI_VRNG_10V,5,PVI_IRNG_100MA,60e-3,-60e-3);
//	Vcc.Enable();
//	Vee.Enable();
//	Vdd.Enable();

	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vdd.Set(FV, 5, FPVI10_10V, FPVI10_100MA, RELAY_ON);

	delay_ms(5);

	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	delay_ms(2);
	
	Create_Awg_Data();
	delay_ms(150);

    vec.UseVoltageSet(0);
	delay_ms(2);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
 	delay_ms(5);
	

	vec.Run(0,4);
	delay_ms(3100);
	while(vec.Running());
	DWORD ern = vec.GetResult();
	if(ern)
	{
		FILE *fp;
		fp = fopen(filename,"w");
		if(fp!=NULL)
		{
			DWORD * pea = new DWORD[61740];
			BYTE * buf = new BYTE [802620];
			int data_num[4096]={0};
			
			assert(pea != NULL);
			assert(buf != NULL);

			vec.GetFailData(ern,pea,buf,outpin,SIZEOF_ARRAY(outpin));

			int adc_data;
		    int i,j;
			int mid_data[12];
			int k;
			for(i=0;i<4096;i++)
			{
				data_num[i]=0;
			}
			for(i=0;i<(int)ern;i++)
			{
			    j=i*13;
				for(k=0;k<12;k++)
				{
					mid_data[k]=(int)buf[j+k];
				}
				adc_data=(mid_data[11]<<11) | (mid_data[10]<<10) | (mid_data[9]<<9) | (mid_data[8]<<8) | (mid_data[7]<<7) | (mid_data[6]<<6) | (mid_data[5]<<5) | (mid_data[4]<<4) | (mid_data[3]<<3) | (mid_data[2]<<2) | (mid_data[1]<<1)|mid_data[0];
                data_num[adc_data]++;          
				fprintf(fp,"%d: %d\n",i,adc_data);
			}
//////////////////////////////////////////////////////////////////
			//ظһ
		    int add_test_time=2;
		 	for(int test_time=1;test_time<add_test_time;test_time++)
			{
				awg0.CNTCLR();
				awg0.CNTEnable();
				delay_ms(10);
				
				vec.Run(0,4);
				
				delay_ms(3100);
				while(vec.Running());
				
				DWORD ern = vec.GetResult();

				vec.GetFailData(ern,pea,buf,outpin,SIZEOF_ARRAY(outpin));
				for(i=0;i<(int)ern;i++)
				{
					j=i*13;
					for(k=0;k<12;k++)
					{
						mid_data[k]=(int)buf[j+k];
					}
					
					adc_data=(mid_data[11]<<11) | (mid_data[10]<<10) | (mid_data[9]<<9) | (mid_data[8]<<8) | (mid_data[7]<<7) | (mid_data[6]<<6) | (mid_data[5]<<5) | (mid_data[4]<<4) | (mid_data[3]<<3) | (mid_data[2]<<2) | (mid_data[1]<<1)|mid_data[0];
					data_num[adc_data]++;          
					//sprintf(str,"%d\n",adc_data);
					//fprintf(fp,"%s",str);
				}
			}
			vec.OpenPinRelay(allpin,SIZEOF_ARRAY(allpin));
			SetCurrentDirectory(temp1);			
			delay_ms(2);
			awg0.CNTCLR();
			awg0.SetOutput(0,AWG_VRNG_10V);
			awg0.Disconnect();
			awg0.SetREF(0);
			awg0.REFDisConnect();
			cbit.SetCBITOff(K1);
			cbit.SetCBITOff(K9);

//			Vdd.Disable();
//			Vee.Disable();
//			Vcc.Disable();

			Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_ON);	
			Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);			
			Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);

			unsigned long all_data_num=0;
			for( i=1; i<4095; i++)
			{
				all_data_num+=data_num[i];
			}
			
			for(i=0;i<4096;i++)
			{
				if (data_num[i])
				fprintf(fp,"%d: %d\n",i,data_num[i]);
			}

			int lsb1=0;
			double lsb=0.0;
			lsb1=int(all_data_num/4094+0.5);
			lsb=all_data_num/4094.0;
			fprintf(fp,"LSB:%d\n",lsb1);
            fprintf(fp,"data_num[0]:%d\n",data_num[0]);
			fprintf(fp,"data_num[4095]:%d\n",data_num[4095]);

			double Ez_result;		           //
			Ez_result=(double)(data_num[0]-300-lsb/2.0)/lsb;
//			Ez_result=(double)(data_num[0]-150-lsb/2.0)/lsb;
            fprintf(fp,"EZ:%f\n",Ez_result);
			
			double Eg_result;		           //
			Eg_result=(double)(data_num[4095]-data_num[0])/lsb;
			fprintf(fp,"EG:%f\n",Eg_result);

			int diff_err=0;
			int max_err=0;
			double DNL_result;
            for(i=1;i<4095;i++)         //΢
			{
				diff_err=data_num[i]-lsb;
				if(fabs(diff_err)>fabs(max_err))
				max_err=diff_err;
			}
			DNL_result=(double)max_err/lsb;
			fprintf(fp,"DNL:%f\n",DNL_result);
			
            double INL_result=0.0,tmp_inl=0.0; //
			for(i=1;i<4095;i++)
			{
				tmp_inl=0.0;
				for(j=1;j<=i;j++)
				{
					tmp_inl+=data_num[j];
				}
				tmp_inl=tmp_inl-(((double)data_num[i]/2.0)+(double)lsb*(i-0.5));
				if(fabs(tmp_inl)>fabs(INL_result))
				{
					INL_result=tmp_inl;
				}
			}
			INL_result/=(double)lsb;
			fprintf(fp,"INL:%f\n",INL_result);
			
			delete [] pea;
			delete [] buf;
			fclose(fp);

			Ez->SetTestResult(0,0,Ez_result);
			Eg->SetTestResult(0,0,Eg_result);
			INL->SetTestResult(0,0,INL_result);
			DNL->SetTestResult(0,0,DNL_result);
			
			fprintf(fp,"\n");
			fclose(fp);
		}
	}

	}




    return 0;
}


// set the gain of PGA204                                             
// gain: one of these values:1,10,100,1000                           

void set_N3_gain(int gain)
{
	const BYTE A0 = 44;
	const BYTE A1 = 45;
	switch(gain) {
	
	case 10:
		cbit.SetCBITOn(A0);
		cbit.SetCBITOff(A1);
		break;
	case 100:
		cbit.SetCBITOff(A0);
		cbit.SetCBITOn(A1);
		break;
	case 1000:
		cbit.SetCBITOn(A0);
		cbit.SetCBITOn(A1);
		break;
	case 1:		
	default:
		cbit.SetCBITOff(A0);
		cbit.SetCBITOff(A1);
		break;
	}		
}

// switch the mux of AD7502                                            
// addr: one of these values:0,1,2,3                                   

void switch_N4(int addr)
{
	const BYTE KA0 = 46;
	const BYTE KA1 = 47;
	switch(addr) {
		
	case 1:
		cbit.SetCBITOn(KA0);
		cbit.SetCBITOff(KA1);
		break;
	case 2:
		cbit.SetCBITOff(KA0);
		cbit.SetCBITOn(KA1);
		break;
	case 3:
		cbit.SetCBITOn(KA0);
		cbit.SetCBITOn(KA1);
		break;
	case 0:		
	default:
		cbit.SetCBITOff(KA0);
		cbit.SetCBITOff(KA1);
		break;
	}
}




DUT_API int PowerSupply(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Icc = StsGetParam(funcindex,"Icc");
    CParam *Iee = StsGetParam(funcindex,"Iee");
    CParam *Ilogic = StsGetParam(funcindex,"Ilogic");
    //}}AFX_STS_PARAM_PROTOTYPES

	float val1[4]={0};
	float val2[4]={0};
	float val3[4]={0};

	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K9);
	
//	Vcc.Connect();
//	Vee.Connect();
//	Vdd.Connect();
	
//	Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_100MA,100e-3,-100e-3);
//	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_100MA,40e-3,-40e-3);
//	Vdd.SetModeFVMI(PVI_VRNG_10V,5,PVI_IRNG_100MA,50e-3,-50e-3);
//	Vcc.Enable();
//	Vee.Enable();
//	Vdd.Enable();

	Vcc.SetClamp(100, 100);
	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);

	Vee.SetClamp(40, 40);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);

	Vdd.SetClamp(50, 50);
	Vdd.Set(FV, 5, FPVI10_10V, FPVI10_100MA, RELAY_ON);

	delay_ms(5);

	awg0.Setup(AWG_VRNG_10V,AWG_NO_Filter);
	awg0.SetOutput(5);
	awg0.Connect();
	delay_ms(2);
	
	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	delay_ms(2);
	
	vec.SetPinVoltage(0);
	delay_ms(2);
	vec.ClosePinRelay(inpin,SIZEOF_ARRAY(inpin));
	delay_ms(5);

	vec.Run(4,4);
	delay_ms(2);
	
//	Vcc.Measure(val1);
	Vcc.MeasureVI(100, 100);
	val1[0]=Vcc.GetMeasResult(0, MIRET);

	if (val1[0]<10e-3)
	{
//		Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_10MA,10e-3,-10e-3);
//		Vcc.Enable();
		Vcc.Set(FV, 15, FPVI10_20V, FPVI10_10MA, RELAY_ON);

		delay_ms(20);

//		Vcc.Measure(val1);

		Vcc.MeasureVI(100, 100);
		val1[0]=Vcc.GetMeasResult(0, MIRET);
		delay_ms(1);

		Icc->SetTestResult(0,0,val1[0]*1000);
	}
    else
	{
		Icc->SetTestResult(0,0,val1[0]*1000);
	}
	
//	Vee.Measure(val2);
	Vee.MeasureVI(100, 100);
	val2[0]=Vee.GetMeasResult(0, MIRET);

	delay_ms(1);
	Iee->SetTestResult(0,0,val2[0]*1000);
	
//	Vdd.Measure(val3);
	Vdd.MeasureVI(100, 100);
	val3[0]=Vdd.GetMeasResult(0, MIRET);

	delay_ms(1);
	Ilogic->SetTestResult(0,0,val3[0]*1000);

	vec.OpenPinRelay(inpin,SIZEOF_ARRAY(inpin));
	awg0.SetOutput(0);
    awg0.Disconnect();
	cbit.SetCBITOff(K1);
	cbit.SetCBITOff(K9);
	awg0.SetREF(0);
	awg0.REFDisConnect();
//	Vdd.Disable();
//	Vee.Disable();
//	Vcc.Disable();

	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_ON);
	delay_ms(2);	
//	Vdd.Disconnect();
//	Vee.Disconnect();
//	Vcc.Disconnect();
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_OFF);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}


DUT_API int Vref(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Vref = StsGetParam(funcindex,"Vref");
    //}}AFX_STS_PARAM_PROTOTYPES
	float val1[4];
	cbit.SetCBITOn(K2);
    cbit.SetCBITOn(K10);

//	Vcc.Connect();
//	Vee.Connect();
//	Vdd.Connect();
	
//	Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_100MA,100e-3,-100e-3);
//	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_100MA,40e-3,-40e-3);
//	Vdd.SetModeFVMI(PVI_VRNG_10V,5,PVI_IRNG_100MA,50e-3,-50e-3);

	Vcc.SetClamp(100, 100);
	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vee.SetClamp(40, 40);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vdd.SetClamp(50, 50);
	Vdd.Set(FV, 5, FPVI10_10V, FPVI10_100MA, RELAY_ON);

//	Vcc.Enable();
//	Vee.Enable();
//	Vdd.Enable();
	delay_ms(5);

	awg0.Setup(AWG_VRNG_10V,AWG_NO_Filter);
	awg0.SetOutput(10,AWG_VRNG_10V);
	awg0.Connect();
	delay_ms(5);
	
	set_N3_gain(100);
	switch_N4(1);
	pvm0.Connect();
	delay_ms(50);
	
//	pvm0.Measure(val1,10);
	pvm0.MeasureLADC(200,5,QVM_LADC_10V,QVM_LADC_40KHz,MEAS_NORMAL);
	val1[0] = pvm0.GetMeasResult(0, AVERAGE_RESULT);
    val1[0]=val1[0]/100+10;
	Vref ->SetTestResult(0,0,val1[0]);
	
	awg0.SetOutput(0);
	awg0.Disconnect();
	cbit.SetCBITOff(K10);
	set_N3_gain(1);
//	Vdd.Disable();
//	Vee.Disable();
//	Vcc.Disable();

	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_ON);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	cbit.SetCBITOff(K2);
	delay_ms(2);	
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_OFF);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
//	Vdd.Disconnect();
//	Vee.Disconnect();
//	Vcc.Disconnect();
	pvm0.Disconnect();
	return 0;
}


DUT_API int Rin(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Rin = StsGetParam(funcindex,"Rin");
    //}}AFX_STS_PARAM_PROTOTYPES

	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K11);
	delay_ms(2);
	float val1[4];
	float val2[4];

//	Vcc.Connect();
//	Vee.Connect();
//	Vdd.Connect();
//	qvi4.Connect();
//	Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_100MA,100e-3,-100e-3);
//	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_100MA,40e-3,-40e-3);
//	Vdd.SetModeFVMI(PVI_VRNG_10V,5,PVI_IRNG_100MA,50e-3,-50e-3);
//	Vcc.Enable();
//	Vee.Enable();
//	Vdd.Enable();
	Vcc.SetClamp(100, 100);
	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vee.SetClamp(40, 40);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vdd.SetClamp(50, 50);
	Vdd.Set(FV, 5, FPVI10_10V, FPVI10_100MA, RELAY_ON);

	delay_ms(5);

//	qvi4.SetModeFVMI(QVI_VRNG_5V,5,QVI_IRNG_10MA,2e-3,-1e-3);
//	qvi4.Enable();

	qvi4.SetClamp(20, 20);		
	qvi4.Set(FV, 5, FOVI_5V, FOVI_10MA, RELAY_ON);

    delay_ms(2);
//	qvi4.Measure(val1,10);
	qvi4.MeasureVI(100, 100);
	val1[0]=qvi4.GetMeasResult(0, MIRET);
	
//	qvi4.SetModeFVMI(QVI_VRNG_5V,-5,QVI_IRNG_10MA,1e-3,-2e-3);
//    qvi4.Enable();
	qvi4.Set(FV, -5, FOVI_5V, FOVI_10MA, RELAY_ON);
    delay_ms(2);
//	qvi4.Measure(val2,10);
	qvi4.MeasureVI(100, 100);
	val2[0]=qvi4.GetMeasResult(0, MIRET);

	val1[0] = (val1[0]-val2[0]);
	if(val1[0]==0)
		val1[0]=1e-9;
    val1[0]=10/val1[0];
	Rin->SetTestResult(0,0,val1[0]/1000);
	
//	qvi4.Disable();
//	qvi4.Disconnect();
	qvi4.Set(FV, 0, FOVI_5V, FOVI_10MA, RELAY_ON);

	cbit.SetCBITOff(K1);
	cbit.SetCBITOff(K11);
//	Vdd.Disable();
//	Vee.Disable();
//	Vcc.Disable();
//	Vdd.Disconnect();
//	Vee.Disconnect();
//	Vcc.Disconnect();
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_ON);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
    delay_ms(2);
	qvi4.Set(FV, 0, FOVI_5V, FOVI_10MA, RELAY_OFF);
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_OFF);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}


DUT_API int Ii(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Iih = StsGetParam(funcindex,"Iih");
    CParam *Iil = StsGetParam(funcindex,"Iil");
    //}}AFX_STS_PARAM_PROTOTYPES

	float val1[4]={0};

//	Vcc.Connect();
//	Vee.Connect();
//	Vdd.Connect();
//	Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_100MA,20e-3,-20e-3);
//	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_100MA,40e-3,-40e-3);
//	Vdd.SetModeFVMI(PVI_VRNG_10V,5,PVI_IRNG_100MA,50e-3,-50e-3);
//	Vcc.Enable();
//	Vee.Enable();
//	Vdd.Enable();
	Vcc.SetClamp(20, 20);
	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vee.SetClamp(40, 40);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vdd.SetClamp(50, 50);
	Vdd.Set(FV, 5, FPVI10_10V, FPVI10_100MA, RELAY_ON);
	delay_ms(5);

	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	
	awg0.Setup(AWG_VRNG_10V,AWG_Filter);
	awg0.Connect();
	delay_ms(5);
	
	vec.UseVoltageSet(0);
	delay_ms(2);
	vec.ClosePinRelay(inpin,SIZEOF_ARRAY(inpin));
	delay_ms(5);

	vec.Run(6,6);
	delay_ms(1);
	for(int i=0;i<4;i++)
	{
		vec.FVMI(inpin[i], FOVI_5V, 0.5, FOVI_10UA, 100, 100, val1, 5, 10);//QVI5V-FOVI5V,QVI10UA-FOVI10UA
		Iil->SetTestResult(0, i, val1[0]*1e6);
	}

	vec.Run(5,5);
	delay_ms(1);
	for(i=0;i<4;i++)
	{
		vec.FVMI(inpin[i],FOVI_5V, 2.5, FOVI_10UA, 100, 100, val1, 5, 10);//QVI5V-FOVI5V,QVI10UA-FOVI10UA
		Iih->SetTestResult(0, i, val1[0]*1e6);
	}

	vec.OpenPinRelay(inpin,SIZEOF_ARRAY(inpin));
	awg0.SetREF(0);
	awg0.REFDisConnect();
	awg0.SetOutput(0);
	awg0.Disconnect();

//	Vdd.Disable();
//	Vee.Disable();
//	Vcc.Disable();
//	Vdd.Disconnect();
//	Vee.Disconnect();
//	Vcc.Disconnect();
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_ON);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
    delay_ms(2);
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_OFF);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);

    return 0;
}


DUT_API int Ioz(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *IOZH = StsGetParam(funcindex,"IOZH");
    CParam *IOZL = StsGetParam(funcindex,"IOZL");
    //}}AFX_STS_PARAM_PROTOTYPES

	float val1[4];
	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K9);

//	Vcc.Connect();
//	Vee.Connect();
//	Vdd.Connect();
//	Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_100MA,20e-3,-20e-3);
//	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_100MA,40e-3,-40e-3);
//	Vdd.SetModeFVMI(PVI_VRNG_10V,5,PVI_IRNG_100MA,50e-3,-50e-3);
//	Vcc.Enable();
//	Vee.Enable();
//	Vdd.Enable();
	Vcc.SetClamp(20, 20);
	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vee.SetClamp(40, 40);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vdd.SetClamp(50, 50);
	Vdd.Set(FV, 5, FPVI10_10V, FPVI10_100MA, RELAY_ON);

	delay_ms(5);
	
	awg0.REFConnect(AWG_REF1);
	awg0.SetREF(10,AWG_REF1);

	awg0.Setup(AWG_VRNG_10V,AWG_Filter);
	awg0.SetOutput(0,AWG_VRNG_10V); 
	awg0.Connect();
	delay_ms(2);

	vec.SetPinVoltage(0);
	delay_ms(2);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
	delay_ms(10);
	
	vec.Run(8,8);
	delay_ms(1);
	for(int i=0;i<12;i++)
	{
//		vec.FVMI(outpin[i], QVI_VRNG_5V, 0, QVI_IRNG_10UA, 10e-6, -10e-6, val1, 5, 10);
		vec.FVMI(outpin[i], FOVI_5V, 0, FOVI_10UA, 100, 100, val1, 5, 10);
		IOZL->SetTestResult(0, i, val1[0]*1e6);
	}
	
	for(i=0;i<12;i++)
	{
//		vec.FVMI(outpin[i], QVI_VRNG_5V, 5, QVI_IRNG_10UA, 10e-6, -10e-6, val1, 5, 10);
		vec.FVMI(outpin[i], FOVI_5V, 5, FOVI_10UA, 100, 100, val1, 5, 10);
		IOZH->SetTestResult(0, i, val1[0]*1e6);
	}

	vec.OpenPinRelay(allpin,SIZEOF_ARRAY(allpin));
	awg0.SetREF(0);
	awg0.REFDisConnect();
	awg0.SetOutput(0);
	awg0.Disconnect();

	cbit.SetCBITOff(K1);
	cbit.SetCBITOff(K9);

//	Vdd.Disable();
//	Vee.Disable();
//	Vcc.Disable();
//	Vdd.Disconnect();
//	Vee.Disconnect();
//	Vcc.Disconnect();
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_ON);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
    delay_ms(2);
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_OFF);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}


DUT_API int Vo(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Voh = StsGetParam(funcindex,"Voh");
    CParam *Vol = StsGetParam(funcindex,"Vol");
    //}}AFX_STS_PARAM_PROTOTYPES

  	float val1[4];
	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K9);

//	Vcc.Connect();
//	Vee.Connect();
//	Vdd.Connect();
//	Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_100MA,20e-3,-20e-3);
//	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_100MA,40e-3,-40e-3);
//	Vdd.SetModeFVMI(PVI_VRNG_10V,5,PVI_IRNG_100MA,50e-3,-50e-3);
//	Vcc.Enable();
//	Vee.Enable();
//	Vdd.Enable();
	Vcc.SetClamp(20, 20);
	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vee.SetClamp(40, 40);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vdd.SetClamp(50, 50);
	Vdd.Set(FV, 5, FPVI10_10V, FPVI10_100MA, RELAY_ON);
	delay_ms(5);
	 
	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);

	awg0.Setup(AWG_VRNG_10V,AWG_Filter);
	awg0.Connect();
	awg0.SetOutput(0,AWG_VRNG_10V);
	delay_ms(5);
		 
	vec.SetPinVoltage(0);
	delay_ms(1);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
	delay_ms(5);

	//ȫ1STSź,̫û취ơ
	awg0.SetOutput(10.1);
	delay_ms(1);

//	vec.Run(6, 6); //all input 1s
//	vec.Run(8, 8); //CS's falling edge trigger the convert

//	vec.Run(5, 5); //all input 0s
//	vec.Run(8, 8); //CE's rising edge trigger the convert

	vec.Run(7, 7);	// R/C's low pulse trigger the convert, 
					//NOTE R/C's t1 must longer (ie>500ns),
					//else there will no convert.
	delay_ms(2);
	
	for(int i=0; i<12; i++)
	{
//	 vec.FIMV(outpin[i], QVI_IRNG_10MA, -0.5e-3, QVI_VRNG_5V, 5, -5, val1, 5, 10);
	 vec.FIMV(outpin[i], FOVI_10MA, -0.5e-3, FOVI_5V, 100, 100, val1, 5, 10);
	 Voh->SetTestResult(0,i,val1[0]);	
	}
	//ȫ0STSźš
	awg0.SetOutput(-0.2);
	vec.Run(7,7);
	delay_ms(1);
	for(i=0; i<13; i++)
	{
//		vec.FIMV(outpin[i], QVI_IRNG_10MA, 1.6e-3, QVI_VRNG_5V, 5, -5, val1, 5, 10);
		vec.FIMV(outpin[i], FOVI_10MA, 1.6e-3, FOVI_5V, 100, 100, val1, 5, 10);
		Vol->SetTestResult(0,i,val1[0]);
	}
	

	vec.OpenPinRelay(allpin,SIZEOF_ARRAY(allpin));
	awg0.SetREF(0);
	awg0.REFDisConnect();
	awg0.SetOutput(0);
	awg0.Disconnect();
	cbit.SetCBITOff(K1);
	cbit.SetCBITOff(K9);
//	Vdd.Disable();
//	Vee.Disable();
//	Vcc.Disable();
//	Vdd.Disconnect();
//	Vee.Disconnect();
//	Vcc.Disconnect();
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_ON);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
    delay_ms(2);
	Vdd.Set(FV, 0, FPVI10_10V, FPVI10_100MA, RELAY_OFF);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
 
    return 0;
}
