#include "stdafx.h"
#include "time.h"
#include <string>

using namespace std;
#define  Delay_Time 1
/**************************************************************************/
/* Do NOT use CBIT::SetOn(...) member function!!!                         */
/* These following procedures USE CBITs.                                  */
/* CBIT::SetCBitOn(...) and CBIT::SetCBitOff(...) functions are prefered. */
/**************************************************************************/
void set_N3_gain(int gain);
void switch_N4(int addr);

//Digital pin definition
DPin_t allpin[17]={11,12,13,14,15,17,18,19,20,21,22,23,24,25,26,27,28};//All pins
//DPin_t inpin[8] ={5,6,7,8,9,10,11,12};//input pins

CVector vec;
CBIT128 cbit;

FPVI10 fpvi0(0); //15V
FPVI10 fpvi1(1);//-15V
FOVI fovi8(8);
QVM qvm0(0);
AWG awg0;
QTMU_PLUS qtmu0(0);
//Relays define 
const BYTE K1 = 56;
const BYTE K2 = 57;
const BYTE K3 = 58;
const BYTE K4 = 59;
const BYTE K5 = 60;
const BYTE K6 = 61;
const BYTE K7 = 62;
const BYTE K8 = 63;
const BYTE K9 = 43;
const BYTE K10= 42;
const BYTE K11= 41;

void Initialize()
{	
	char temp[100]="";
	GetCurrentDirectory(100,temp);
	string dir(temp);
	int x = dir.find("source");
	if (x > 0)
	{
		string newdir = dir.substr(0,x);
		SetCurrentDirectory(newdir.c_str());
	}
       vec.SetVectorFile("AD667.vec");//ļ*.vec
}


void InitBeforeTest()
{
	cbit.Init();
	set_N3_gain(1);
	switch_N4(0);
	fpvi0.SetClamp(100, 100);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.SetClamp(100, 100);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	vec.Load();
	fovi8.SetClamp(100, 100);		
	fovi8.Set(FV, 0, FOVI_5V, FOVI_10MA, RELAY_OFF);
	qvm0.Init();
	awg0.Init();
	qtmu0.Init();
}
void InitAfterTest()
{


	cbit.Init();
	set_N3_gain(1);
	switch_N4(0);
	fpvi0.SetClamp(30, 10);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.SetClamp(10, 30);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fovi8.SetClamp(100, 100);		
	fovi8.Set(FV, 0, FOVI_5V, FOVI_10MA, RELAY_OFF);
	qvm0.Init();
	awg0.Init();
	vec.Unload();
	qtmu0.Init();


}
	
/************************************************************************/
/* set the gain of PGA204                                               */
/* gain: one of these values:1,10,100,1000                              */
/************************************************************************/
void set_N3_gain(int gain)
{
	const BYTE A0 = 44;
	const BYTE A1 = 45;
	switch(gain) {
		
	case 10:
		cbit.SetCBITOn(A0);
		cbit.SetCBITOff(A1);
		break;
	case 100:
		cbit.SetCBITOff(A0);
		cbit.SetCBITOn(A1);
		break;
	case 1000:
		cbit.SetCBITOn(A0);
		cbit.SetCBITOn(A1);
		break;
	case 1:		
	default:
		cbit.SetCBITOff(A0);
		cbit.SetCBITOff(A1);
		break;
	}		
}
/************************************************************************/
/* switch the mux of AD7502                                             */
/* addr: one of these values:0,1,2,3                                    */
/************************************************************************/
void switch_N4(int addr)
{
	const BYTE KA0 = 46;
	const BYTE KA1 = 47;
	switch(addr) {
		
	case 1:
		cbit.SetCBITOn(KA0);
		cbit.SetCBITOff(KA1);
		break;
	case 2:
		cbit.SetCBITOff(KA0);
		cbit.SetCBITOn(KA1);
		break;
	case 3:
		cbit.SetCBITOn(KA0);
		cbit.SetCBITOn(KA1);
		break;
	case 0:		
	default:
		cbit.SetCBITOff(KA0);
		cbit.SetCBITOff(KA1);
		break;
	}
}






/************************************************************************/
/*                          Icc test                                    */
/************************************************************************/




DUT_API int TEST_Icc(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Icc = StsGetParam(funcindex,"Icc");
	CParam *Iee = StsGetParam(funcindex,"Iee");
//	CParam *Pd = StsGetParam(funcindex,"Pd");
    //}}AFX_STS_PARAM_PROTOTYPES
    // TODO: Add your function code here
	double vcc = Icc->GetConditionCurSelDouble("vcc");
	double vee = Icc->GetConditionCurSelDouble("vee");

	double delay = Icc->GetConditionCurSelDouble("delay");
	float val1[4];
	float val2[4];

	fpvi0.Set(FV, fabs(vcc), FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, -fabs(vee), FPVI10_20V, FPVI10_100MA, RELAY_ON);

	delay_ms(10);
	
	awg0.SetREF(10);
	awg0.REFConnect();

	delay_ms(1);


 	delay_ms(delay);
	//test
	fpvi0.MeasureVI(100, 100);
	val1[0]=fpvi0.GetMeasResult(0, MIRET);
	fpvi1.MeasureVI(100, 100);
	val2[0]=fpvi1.GetMeasResult(0, MIRET);
// 	Vcc.Measure(val1);//Icc
// 	Vee.Measure(val2);//Iee

	Icc->SetTestResult(0,0,val1[0]*1000);
	Iee->SetTestResult(0,0,val2[0]*1000);
//	Pd->SetTestResult(0,0,1000*(fabs(vcc*val1[0])+fabs(vee*val2[0])));


	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(delay);
	cbit.SetCBITOff(K10);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	
    return 0;
}



/************************************************************************/
/*  Iih,Iil test                                                        */
/************************************************************************/



DUT_API int TEST_Ii(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Iih = StsGetParam(funcindex,"Iih");
    CParam *Iil = StsGetParam(funcindex,"Iil");
    //}}AFX_STS_PARAM_PROTOTYPES
	
    // TODO: Add your function code here
	double delay = Iih->GetConditionCurSelDouble("delay");
	double vil = Iih->GetConditionCurSelDouble("vil");
	double vih = Iih->GetConditionCurSelDouble("vih");
	float val1[4];
	int i;
	fpvi0.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(delay);	
	vec.UseVoltageSet(0);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
	delay_ms(2);
	
	vec.Run(0,0);
	delay_ms(1);
	
	//IIH
	for( i=0;i<17;i++)
	{

		vec.FVMI(allpin[i], FOVI_10V, vil, FOVI_100UA, 100, 100, val1, 5, 10);//QVI5V-FOVI5V,QVI10UA-FOVI10UA

		Iil->SetTestResult(0,i,(val1[0])*1E6);
	}
	
	vec.Run(5,5);
	//IIl
	for( i=0;i<17;i++)
	{

		vec.FVMI(allpin[i], FOVI_10V, vih, FOVI_100UA, 100, 100, val1, 5, 10);//QVI5V-FOVI5V,QVI10UA-FOVI10UA

		Iih->SetTestResult(0,i,(val1[0])*1E6);
	}
	
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(delay);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}



/************************************************************************/
/*                                                                      */
/************************************************************************/



DUT_API int TEST_Io(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Ioh = StsGetParam(funcindex,"Ioh");
    CParam *Iol = StsGetParam(funcindex,"Iol");
    //}}AFX_STS_PARAM_PROTOTYPES
	
    // TODO: Add your function code here
	double delay = Ioh->GetConditionCurSelDouble("delay");
	double vol = Ioh->GetConditionCurSelDouble("vol");
	double voh = Ioh->GetConditionCurSelDouble("voh");
	float val1[4];
	float val2[4];
	float val3[4];
	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K11);
//	fovi8.Set(FI,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	fpvi0.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(delay);		
	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	vec.UseVoltageSet(0);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
	delay_ms(2);
	vec.Run(1,1);
	delay_ms(2);
// 	fovi8.MeasureVI(10,10);
//     val1[0]=fovi8.GetMeasResult(0,MVRET);
	fovi8.Set(FV,4.8,FOVI_20V,FOVI_10MA,RELAY_ON);
    delay_ms(delay);
	fovi8.MeasureVI(10,10);
     val2[0]=fovi8.GetMeasResult(0,MIRET);
     Ioh->SetTestResult(0,0,val2[0]*1e3);
	 if (fabs(val2[0])>=9.9*1e-3)
	 {
		 Ioh->SetResultRemark(0,0,"clamp");
	 }


	fovi8.Set(FV,5.2,FOVI_20V,FOVI_10MA,RELAY_ON);
    delay_ms(delay);
	fovi8.MeasureVI(10,10);
    val3[0]=fovi8.GetMeasResult(0,MIRET);
	Iol->SetTestResult(0,0,val3[0]*1e3);
	if (fabs(val3[0])>=9.9*1e-3)
	{
		Iol->SetResultRemark(0,0,"clamp");
	}

	fovi8.Set(FI,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(2);
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	delay_ms(delay);
	cbit.Init();
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_OFF);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}



/************************************************************************/
/*                                                                      */
/************************************************************************/



DUT_API int TEST_Ro(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Ro = StsGetParam(funcindex,"Ro");
    //}}AFX_STS_PARAM_PROTOTYPES
	
    // TODO: Add your function code here
	double delay = Ro->GetConditionCurSelDouble("delay");
	float val1[4];
	float val2[4];
	float val3[4];
	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K11);
	//	fovi8.Set(FI,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	fpvi0.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(delay);		
	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	vec.UseVoltageSet(0);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
	delay_ms(2);
	vec.Run(1,1);
	delay_ms(2);
	// 	fovi8.MeasureVI(10,10);
	//     val1[0]=fovi8.GetMeasResult(0,MVRET);
	fovi8.Set(FI,15*1e-3,FOVI_20V,FOVI_100MA,RELAY_ON);
	fovi8.SetClamp(10,50);
    delay_ms(delay);
	fovi8.MeasureVI(10,10);
	val1[0]=fovi8.GetMeasResult(0,MVRET);

	fovi8.Set(FI,20*1e-3,FOVI_20V,FOVI_100MA,RELAY_ON);
	fovi8.SetClamp(10,50);
    delay_ms(delay);
	fovi8.MeasureVI(10,10);
	val2[0]=fovi8.GetMeasResult(0,MVRET);

	Ro->SetTestResult(0,0,(val2[0]-val1[0])/5*1e3);
	
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(2);
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	delay_ms(delay);
	cbit.Init();
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_OFF);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}

/************************************************************************/
/*                                                                      */
/************************************************************************/



DUT_API int TEST_Ios(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Ios = StsGetParam(funcindex,"Ios");
    //}}AFX_STS_PARAM_PROTOTYPES
	
    // TODO: Add your function code here
	double delay = Ios->GetConditionCurSelDouble("delay");
	float val1[4];
	float val2[4];
	float val3[4];
	int i;
	cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K11);
	//	fovi8.Set(FI,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	fpvi0.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(delay);		
	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	vec.UseVoltageSet(0);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
	delay_ms(2);
	vec.Run(1,1);
	delay_ms(2);
	// 	fovi8.MeasureVI(10,10);
	//     val1[0]=fovi8.GetMeasResult(0,MVRET);
	fovi8.Set(FV,0,FOVI_20V,FOVI_100MA,RELAY_ON);
	fovi8.SetClamp(10,50);
    delay_ms(delay);
	fovi8.MeasureVI(10,10);
	val1[0]=fovi8.GetMeasResult(0,MIRET);
	Ios->SetTestResult(0,0,val1[0]*1e3);

	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(2);
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	delay_ms(delay);
	cbit.Init();
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_OFF);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}





/************************************************************************/
/*                                                                      */
/************************************************************************/



DUT_API int TEST_SR(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *SR = StsGetParam(funcindex,"SR");
    //}}AFX_STS_PARAM_PROTOTYPES
	
    // TODO: Add your function code here
	double val1[16];
	float val2[4];
	float val3[4];
	int i;
	//	fovi8.Set(FI,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	fpvi0.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(5);		
	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	vec.UseVoltageSet(0);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
	delay_ms(2);
	vec.Run(10,10);
	delay_ms(2);

	qtmu0.SetStartInput(QTMU_PLUS_IMPEDANCE_1M,	QTMU_PLUS_VRNG_25V,QTMU_PLUS_FILTER_10MHz);
	qtmu0.SetStopInput(QTMU_PLUS_IMPEDANCE_1M,	QTMU_PLUS_VRNG_25V,QTMU_PLUS_FILTER_10MHz);
	qtmu0.SetStartTrigger(2,QTMU_PLUS_POS_SLOPE);
	qtmu0.SetStopTrigger(7,QTMU_PLUS_POS_SLOPE);
	qtmu0.SetInSource(QTMU_PLUS_SINGLE_SOURCE);
	qtmu0.Connect();
	qtmu0.SetSinglePulseMeas(QTMU_PLUS_COARSE,QTMU_PLUS_TIME_NS,0);
	qtmu0.SetTimeOut(5);
	
	vec.Run(4105,4105);

    while(vec.Running());
    qtmu0.SinglePulseMeas(val1,0);


	SR->SetTestResult(0,0,5/val1[0]);
	
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(2);
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	delay_ms(5);
	cbit.Init();
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_OFF);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}

/************************************************************************/
/*                                                                      */
/************************************************************************/



DUT_API int TEST_VREF(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *VREF = StsGetParam(funcindex,"VREF");
    //}}AFX_STS_PARAM_PROTOTYPES
	
    // TODO: Add your function code here
	double delay = VREF->GetConditionCurSelDouble("delay");
	float val1[4];
	float val2[4];
	float val3[4];
	int i;
	cbit.SetCBITOn(K2);
	cbit.SetCBITOn(K11);
	//	fovi8.Set(FI,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	fpvi0.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(delay);		
	awg0.SetREF(10,AWG_REF1);
	awg0.REFConnect(AWG_REF1);
	vec.UseVoltageSet(0);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));
	delay_ms(2);
	vec.Run(1,1);
	delay_ms(2);
	// 	fovi8.MeasureVI(10,10);
	//     val1[0]=fovi8.GetMeasResult(0,MVRET);
	fovi8.Set(FI,0,FOVI_20V,FOVI_100MA,RELAY_ON);
    delay_ms(delay);
	fovi8.MeasureVI(10,10);
	val1[0]=fovi8.GetMeasResult(0,MVRET);
	VREF->SetTestResult(0,0,val1[0]);
	
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(2);
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_ON);
	delay_ms(delay);
	cbit.Init();
	fovi8.Set(FV,0,FOVI_20V,FOVI_10MA,RELAY_OFF);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
    return 0;
}
/************************************************************************/
/* IREF                                                                 */
/************************************************************************/
/*

DUT_API int TEST_Iref(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *Iref = StsGetParam(funcindex,"Iref");
    //}}AFX_STS_PARAM_PROTOTYPES
    // TODO: Add your function code here
	double delay = Iref->GetConditionCurSelDouble("delay");
	float val1[4];

	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_10MA, RELAY_ON);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_10MA, RELAY_ON);

//	Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_10MA,5e-3,-1e-3);
//	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_10MA,5e-3,-10e-3);

//	pvi2.SetModeFIMV(PVI_IRNG_1MA,0,PVI_VRNG_1V,1,-1);
    pvi2.Set(FI,0,FPVI10_1V,FPVI10_1MA,RELAY_ON);
	
	
	awg0.SetREF(10);
	awg0.REFConnect();
	awg0.Setup(AWG_VRNG_10V,AWG_Filter);
	delay_ms(delay);
	
	//test
//	pvi2.Measure(val1);
	pvi2.MeasureVI(100, 100);
	val1[0]=pvi2.GetMeasResult(0, MVRET);
	Iref->SetTestResult(0,0,(10-val1[0])/5);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_ON);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_ON);
	pvi2.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_ON);
	delay_ms(delay);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_OFF);
	pvi2.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_OFF);

    return 0;
}

/************************************************************************/
/* INL,DNL,FSR,Ez,Eg,LSB test                                           */
/************************************************************************/







DUT_API int TEST_ERROR(short funcindex, LPCTSTR funclabel)
{
    //{{AFX_STS_PARAM_PROTOTYPES
    CParam *INL = StsGetParam(funcindex,"INL");
    CParam *DNL = StsGetParam(funcindex,"DNL");
    CParam *Ez = StsGetParam(funcindex,"Ez");
    CParam *Eg = StsGetParam(funcindex,"Eg");
    //}}AFX_STS_PARAM_PROTOTYPES
	int g_print=Ez->GetConditionValueSelOrder("g_print");
    // TODO: Add your function code here
	float val1[4];
	qvm0.Connect();
	if (g_print==0)
	{
		/*
	Vcc.Set(FV, 15, FPVI10_20V, FPVI10_10MA, RELAY_ON);
	Vee.Set(FV, -15, FPVI10_20V, FPVI10_10MA, RELAY_ON);

// 	Vcc.SetModeFVMI(PVI_VRNG_20V,15,PVI_IRNG_10MA,5e-3,-10e-3);
// 	Vee.SetModeFVMI(PVI_VRNG_20V,-15,PVI_IRNG_10MA,5e-3,-10e-3);

	delay_ms(5);
	//	awg
	//һ̶ֵ
	awg0.SetREF(10);
	awg0.REFConnect();
	awg0.Setup(AWG_VRNG_10V,AWG_Filter);
	awg0.SetOutput(0);
	awg0.Connect();
	delay_ms(1);
	//test
    vec.UseVoltageSet(0);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));

//	#ifdef NEW_SH8201
//	cbit.SetCBITOn(K10);
//	#endif

	cbit.SetCBITOn(K10);

    //liangcheng
	switch_N4(2);
	//set_N3_gain(10);
	set_N3_gain(100);
	delay_ms(1);
    //pvm
//	pvm0.SetInputMode(IN_MODE_SE);
	

	float output_v[256];

		//ת0255
    	for(int i=0;i<256;i++)
		{
            double tmp;
			tmp=10.0*i/256.;
			awg0.SetOutput(tmp);
//		    awg0.SetOutput(0);
			vec.Run(i,i);
			delay_ms(1);
 			while(vec.Running());
			pvm0.MeasureLADC(10,10,QVM_LADC_10V,QVM_LADC_10KHz,MEAS_NORMAL);
			delay_ms(1);
			val1[0]=pvm0.GetMeasResult(0,AVERAGE_RESULT);
		//	pvm0.Measure(val1);
			output_v[i]=(float)(tmp+val1[0]/100);
			//output_v[i]=(float)val1[0];
			//sprintf(str,"%f\n",val1[0]);
			//fprintf(fp,"%s",str);
		}
// 		for( i=0;i<256;i++)
// 		{ 
// 			sprintf(str,"%f\n",output_v[i]);
// 			fprintf(fp,"%s",str);
// 		}
		float LSB;
		float VFSR;
		float VOFFSET,GE;
        
		VFSR=output_v[255]-output_v[0];
		LSB=VFSR/255;
		VOFFSET=output_v[0]/LSB;
		GE=(9.9607-VFSR)/LSB;
		
		float DNL_DATA[256];
		float Max_DNL=0;
		for(i=1;i<256;i++)
		{
			DNL_DATA[i]=output_v[i]-output_v[i-1]-LSB;
			if (fabs(DNL_DATA[i])>fabs(Max_DNL))
				Max_DNL=DNL_DATA[i];
		}
		Max_DNL/=-LSB;

		
		float INL_DATA[256];
		for(i=0;i<256;i++)
		    	INL_DATA[i]=0;
		float Max_INL=0;
		for(i=1;i<256;i++)
		{
			for(int k=1;k<=i;k++)
			{
				INL_DATA[i]+=DNL_DATA[k];
			}
			if (fabs(INL_DATA[i])>fabs(Max_INL))
				Max_INL=INL_DATA[i];
		}
		Max_INL/=-LSB;

        Ez->SetTestResult(0,0,VOFFSET);
		Eg->SetTestResult(0,0,GE);
		INL->SetTestResult(0,0,Max_INL);
		DNL->SetTestResult(0,0,Max_DNL);
	

	cbit.SetCBITOff(K10);
	
	vec.OpenPinRelay(allpin,SIZEOF_ARRAY(allpin));
	
	awg0.REFDisConnect();
	awg0.Disconnect();
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_ON);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_ON);
	delay_ms(10);
	Vee.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_OFF);
	Vcc.Set(FV, 0, FPVI10_20V, FPVI10_10MA, RELAY_OFF);*/
	} 
	else
	{
		
		cbit.SetCBITOn(K1);
	cbit.SetCBITOn(K10);
	fpvi0.Set(FV, 15, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, -15, FPVI10_20V, FPVI10_100MA, RELAY_ON);

	delay_ms(5);

// 	awg0.SetREF(10.0,AWG_REF1);
// 	awg0.REFConnect(AWG_REF1);

	awg0.Setup(AWG_VRNG_10V,AWG_Filter);
	awg0.SetOutput(0);
	awg0.Connect();
	delay_ms(1);
	//test
    vec.UseVoltageSet(0);
	vec.ClosePinRelay(allpin,SIZEOF_ARRAY(allpin));


	switch_N4(1);
	//set_N3_gain(10);
	set_N3_gain(100);
	delay_ms(1);


	char str[100];
	float output_v[4096];
	FILE *fp;
	fp = fopen("DAC08.log","w");
	if(fp!=NULL)
	{
    	for(int i=0;i<4096;i++)
		{
            double tmp;
			tmp=10.0*i/4096.;
			awg0.SetOutput(tmp);
//		    awg0.SetOutput(0);
			vec.Run(i+10,i+10);
			delay_ms(1);
			if (i==4095)
			{
				delay_ms(1);
			}
 			while(vec.Running());
			delay_ms(1);	
			qvm0.MeasureLADC(10,10,QVM_LADC_10V,QVM_LADC_10KHz,MEAS_NORMAL);

			val1[0]=qvm0.GetMeasResult(0,AVERAGE_RESULT);
		//	pvm0.Measure(val1);
			output_v[i]=(float)(tmp+val1[0]/100);
			//output_v[i]=(float)val1[0];
			//sprintf(str,"%f\n",val1[0]);
			//fprintf(fp,"%s",str);
		}
		for( i=0;i<4096;i++)
		{ 
			sprintf(str,"%f\n",output_v[i]);
			fprintf(fp,"%s",str);
		}
		float LSB;
		float VFSR;
		float EZ,GE;
        
		VFSR=output_v[4095]-output_v[0];
		LSB=VFSR/4095;
		EZ=output_v[0]/LSB;
		GE=(10-VFSR)/VFSR*100;
		
		float DNL_DATA[4096];
		float Max_DNL=0;
		for(i=1;i<4096;i++)
		{
			DNL_DATA[i]=output_v[i]-output_v[i-1]-LSB;
			if (fabs(DNL_DATA[i])>fabs(Max_DNL))
				Max_DNL=DNL_DATA[i];
		}
		Max_DNL/=-LSB;

		
		float INL_DATA[4096];
		for(i=0;i<4096;i++)
		    	INL_DATA[i]=0;
		float Max_INL=0;
		for(i=1;i<4096;i++)
		{
			for(int k=1;k<=i;k++)
			{
				INL_DATA[i]+=DNL_DATA[k];
			}
			if (fabs(INL_DATA[i])>fabs(Max_INL))
				Max_INL=INL_DATA[i];
		}
		Max_INL/=-LSB;

        Ez->SetTestResult(0,0,EZ);
		Eg->SetTestResult(0,0,GE);
		INL->SetTestResult(0,0,Max_INL);
		DNL->SetTestResult(0,0,Max_DNL);
		sprintf(str,"EZ:%f\n",EZ);
		fprintf(fp,"%s",str);
		sprintf(str,"GE:%f\n",GE);
		fprintf(fp,"%s",str);
		sprintf(str,"DNL:%f\n",Max_DNL);
		fprintf(fp,"%s",str);
		sprintf(str,"INL:%f\n",Max_INL);
		fprintf(fp,"%s",str);
		sprintf(str,"VFSR:%f\n",VFSR);
		fprintf(fp,"%s",str);
		sprintf(str,"LSB:%f\n",LSB);
		fprintf(fp,"%s",str);

	}
	fprintf(fp,"\n");
	fclose(fp);
	cbit.SetCBITOff(K10);
	cbit.SetCBITOff(K1);
	vec.OpenPinRelay(allpin,SIZEOF_ARRAY(allpin));
	
	awg0.REFDisConnect();
	awg0.Disconnect();
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_ON);
	delay_ms(10);
	fpvi1.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	fpvi0.Set(FV, 0, FPVI10_20V, FPVI10_100MA, RELAY_OFF);
	}
     qvm0.Disconnect();
    return 0;
}










